if (typeof dwr == 'undefined' || dwr.engine == undefined) throw new Error('You must include DWR engine before including this file');

(function() {
  if (dwr.engine._getObject("testDwrRevAction") == undefined) {
    var p;
    
    p = {};

    /**
     * @param {class java.lang.String} p0 a param
     * @param {function|Object} callback callback function or options object
     */
    p.initData = function(p0, callback) {
      return dwr.engine._execute(p._path, 'testDwrRevAction', 'initData', arguments);
    };

    /**
     * @param {class java.lang.String} p0 a param
     * @param {class java.lang.String} p1 a param
     * @param {class java.lang.String} p2 a param
     * @param {class java.lang.String} p3 a param
     * @param {function|Object} callback callback function or options object
     */
    p.sendMsg = function(p0, p1, p2, p3, callback) {
      return dwr.engine._execute(p._path, 'testDwrRevAction', 'sendMsg', arguments);
    };

    /**
     * @param {class java.lang.String} p0 a param
     * @param {class java.lang.String} p1 a param
     * @param {class java.lang.String} p2 a param
     * @param {class java.lang.String} p3 a param
     * @param {class java.lang.String} p4 a param
     * @param {function|Object} callback callback function or options object
     */
    p.exeConnection = function(p0, p1, p2, p3, p4, callback) {
      return dwr.engine._execute(p._path, 'testDwrRevAction', 'exeConnection', arguments);
    };
    
    dwr.engine._setObject("testDwrRevAction", p);
  }
})();

