(function($, owner) {
	owner.engine = (dwr && dwr.engine) || {};
	owner.me = '';
	owner.receiveMsgCallback = $.noop;
	// init && connect to server
	owner.init = function(id, recMsgCallback, callback) {
//		window.console && window.console.log('start init, id: ' + id);
		if (!id) {
			return;
		}
		owner.me = id;
		owner.receiveMsgCallback = recMsgCallback;
		owner.engine.setErrorHandler(function(msg, exc) {
			window.console && window.console.log('error occur, msg: ' + msg + '  detail: ' + dwr.util.toDescriptiveString(exc, 2));
		});
//		owner.engine.setWarningHandler(function(msg) {
//			window.console && window.console.log('warning, msg: ' + msg);
//		});
//		owner.engine.setTextHtmlHandler(function(pageData) {
//			window.console && window.console.log('TextHtmlHandler' + pageData);
//		});
		owner.engine.setOverridePath(commonProtocol.serverDomain + '/dwr');
		owner.engine.setActiveReverseAjax(true);
		testDwrRevAction.initData(id, function(resultData) {
//			window.console && window.console.log('finish init testDwrRevAction, result: ' + resultData);
			callback && callback(resultData);
		});
	};
	
	// get msg type number by type text
	owner.msgTypeText2Num = function(type) {
		switch (type) {
			case 'text':
				return 0;
			case 'image':
				return 1;
			case 'audio':
				return 2;
			case 'vedio':
				return 3;
			default:
				return 0;
		}
	};
	// send msg, type: 0(text), 1(image), 2(audio), 3(video)
	owner.sendMsg = function(iden, msg, type, to, callback) {
//		window.console && window.console.log('will send msg: ' + msg + ', to: ' + to + ',  type: ' + type + ',  iden : ' + iden);
		if (!to || !msg || !type) {
			return;
		}
		iden = iden || '';
		testDwrRevAction.sendMsg(msg, to, owner.me, owner.msgTypeText2Num(type), function(resultData) {
//			window.console && window.console.log('msg has been sent, result: ' + resultData);
			if ('string' == typeof resultData) {
				resultData = resultData.replace(/\'/g, '"');
				try {
					resultData = JSON.parse(resultData);
				} catch (ex) {
//					window.console && window.console.log('fail to parse data: ' + resultData);
					resultData = {iden: iden, failed: true};
				}
			}
			resultData.iden = iden;
			callback && callback(resultData);
		});
	};
}(mui, window.wsListener = {}));
// dwr推送消息
function callbackmsg(data) {
	window.console && console.log('receive msg, data: ' + data);
	if ('string' == typeof data) {
		data = data.replace(/\'/g, '"');
		try {
			data = JSON.parse(data);
		} catch (ex) {
			data = {};
//			window.console && window.console.log('fail to parse data: ' + data);
		}
	}
	window.wsListener.receiveMsgCallback && window.wsListener.receiveMsgCallback(data);
}
